<script lang="ts" setup>
import { onMounted, ref, unref } from 'vue';

import { useVbenModal } from '@vben/common-ui';

import { message } from 'ant-design-vue';

import { useFormOptions, useVbenForm } from '#/adapter';
import { ConfigApi } from '#/api';

import { useSchema } from '../data.config';

defineOptions({
  name: 'ConfigEdit',
});
const emit = defineEmits(['success']);
const modelRef = ref<Record<string, any>>({});
const isUpdate = ref(true);

const [Form, { validate, setValues, getValues }] = useVbenForm(
  useFormOptions({
    schema: useSchema(),
  }),
);

const [Modal, { close, setState, getData }] = useVbenModal({
  fullscreenButton: false,
  draggable: true,
  onCancel() {
    close();
  },
  onConfirm: async () => {
    try {
      const { valid } = await validate();
      if (valid) {
        const values = await getValues();
        setState({ confirmLoading: true });
        const postParams = unref(modelRef);
        Object.assign(postParams, values);
        await (unref(isUpdate)
          ? ConfigApi.editDetail(postParams as ConfigApi.RecordItem)
          : ConfigApi.addDetail(postParams as ConfigApi.BasicRecordItem));
        message.success('操作成功');

        close();
        emit('success');
      }
    } finally {
      setState({ confirmLoading: false });
    }
  },
  onOpenChange: async (isOpen: boolean) => {
    if (isOpen) {
      setState({ loading: true });
      const data = getData<Record<string, any>>();
      isUpdate.value = !!data.isUpdate;
      modelRef.value = { ...data.baseData };
      setState({ title: unref(isUpdate) ? '编辑系统配置' : '新增系统配置' });

      if (unref(isUpdate)) {
        const entity = await ConfigApi.getDetail(data.baseData.id);
        modelRef.value = { ...entity };
        setValues(entity);
      }
      setState({ loading: false });
    }
  },
  title: '新增系统配置',
});

onMounted(async () => {});
</script>
<template>
  <Modal class="w-[1000px]">
    <Form />
  </Modal>
</template>
